class ExpressionTree {

  static final int Y_SPACE = 75;
  static final int PRE = 0;
  static final int POST = 1;
  static final int IN = 2;

  ExpressionTreeNode root;
  int totalLevels;

  ExpressionTree(int x, int y, int numLevels) {
    totalLevels = numLevels;
    root = makeTree(x, y, numLevels);
    populateTree(root);
  }//constructor

  /* =====================================
  TODO: Traverse the tree rooted at current, setting value and type.
  
  If current is a leaf: 
  - set type to ExpressionTreeNode.VAL
  - set value to a random float in the range [0 ... 10)
  
  If current is not a leaf:
  - set type to a random integer in the range [0,3]. This will correspond to 
    constants PLUS, MINUS, TIMES, or DIVIDE from ExpressionTreeNode.
  - leave value alone

  =======================================*/
  void populateTree(ExpressionTreeNode current) {
    
  }//populateTree



  String traverse(int type) {
    if (type == PRE)
      return preOrder(root);
    else if (type == POST)
      return postOrder(root);
    else if (type == IN)
      return inOrder(root);
    return "";
  }

  String preOrder(ExpressionTreeNode current) {
    if (current == null) { return ""; }
    return current.value+ " " + preOrder(current.left) + preOrder(current.right);
  }

  String postOrder(ExpressionTreeNode current) {
    if (current == null) { return ""; }
    return postOrder(current.left) + postOrder(current.right) + current.value + " ";
  }


  /* =====================================
  TODO: Modify me to return a valid infix expression representation of the
  tree, with parentheses around each operation
  
  example output: "((7.0 / (4.0 + 5.0)) * (3.0 * 6.0))"
  =======================================*/
  String inOrder(ExpressionTreeNode current) {
    if (current == null) { return ""; }
    return inOrder(current.left) + current.value + " " +  inOrder(current.right);
    
  }

  /*======================================
  TODO: recursively evaluate the expression tree rooted at current.

  If current is an operator node, set its value to the result 
  of applying the operator to the values of its subtrees.

  Return the result of fully evaluating the tree rooted at current.
  ======================================*/
  float evaluate() { return evaluate(root); }
  float evaluate(ExpressionTreeNode current) {
    return 0;
  }//evaluate



  ExpressionTreeNode makeTree(int x, int y, int numLevels) {
    if (numLevels == 0) { return null; }

    ExpressionTreeNode newNode = new ExpressionTreeNode(x, y, 0, 0);

    float xoffset = width / (pow(2, totalLevels - numLevels+2));
    int leftX = int(x + xoffset * -1);
    int rightX = int(x + xoffset);
    int newY = y + Y_SPACE;

    int depth = totalLevels - numLevels + 1; //depth 1 is root
    float treeChance = 0.8 / pow(2, depth-2);
    //println("depth, treechance", depth, treeChance);
    if(random(1) < treeChance) {
      newNode.left = makeTree(leftX, newY, numLevels-1);
      newNode.right = makeTree(rightX, newY, numLevels-1);
    }

    return newNode;
  }//makeTree


  void display() { display(root); }
  void display(ExpressionTreeNode current) {
    if (current != null) {
      current.display();
      display(current.left);
      display(current.right);
    }
  }//display

}//OrbTree
