color col_red = color(200, 0, 0);
color col_green = color(50, 200, 50);

color col_white = color(255, 255, 255);
color col_blue = color(180, 240, 255);
color col_yellow = color(255, 255, 50);

class ExpressionTreeNode {

  static final int NODE_SIZE = 45;

  //Type constants
  static final int PLUS = 0;
  static final int MINUS = 1;
  static final int TIMES = 2;
  static final int DIVIDE = 3;
  static final int VAL = 4;



  PVector position;
  int psize;
  color c;

  //Node data
  float value;
  int type;

  ExpressionTreeNode left;
  ExpressionTreeNode right;

  ExpressionTreeNode(int x, int y, int t, int v) {
    position = new PVector(x, y);
    psize = NODE_SIZE;
    left = null;
    right = null;
    c = col_white;
    type = t;
    value = v;
  }//constructor

  void display() {
    if (left != null) {
      stroke(col_green);
      line(position.x, position.y, left.position.x, left.position.y);
    }
    if (right != null) {
      stroke(col_red);
      line(position.x, position.y, right.position.x, right.position.y);
    }
    
    //draw circle
    stroke(color(0));
    fill(c);
    circle(position.x, position.y, psize);
    
    //text
    fill(0);
    textSize(15);
    textAlign(CENTER, TOP);
    
    //print value
    String roundedVal = nf(value, 0, 2); //round to 2 decimal places
    text(roundedVal, position.x, position.y-4);
    
    //print operator
    if (type != VAL) {
      char o = ' ';
      if      (type == PLUS)   { o = '+'; }
      else if (type == MINUS)  { o = '-'; }
      else if (type == TIMES)  { o = '*'; }
      else if (type == DIVIDE) { o = '/'; }
      textAlign(CENTER, BASELINE);
      text(o, position.x, position.y-4);
    }
  }//display

}//Orb
